from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, Boolean, String, File, Directory

Exclude_Uid_Lists_V0_1_0 = CommandToolBuilder(tool="exclude_uid_lists", base_command=["exclude-uid-lists"], inputs=[ToolInput(tag="in_batch_size", input_type=Int(optional=True), prefix="--batch-size", doc=InputDocumentation(doc="merge at most NMERGE inputs at once;")), ToolInput(tag="in_ignore_leading_blanks", input_type=Boolean(optional=True), prefix="--ignore-leading-blanks", doc=InputDocumentation(doc="ignore leading blanks")), ToolInput(tag="in_compress_program", input_type=String(optional=True), prefix="--compress-program", doc=InputDocumentation(doc="compress temporaries with PROG;")), ToolInput(tag="in_dictionary_order", input_type=Boolean(optional=True), prefix="--dictionary-order", doc=InputDocumentation(doc="consider only blanks and alphanumeric characters")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="annotate the part of the line used to sort,\ndecompress them with PROG -d")), ToolInput(tag="in_ignore_case", input_type=Boolean(optional=True), prefix="--ignore-case", doc=InputDocumentation(doc="fold lower case to upper case characters")), ToolInput(tag="in_files_zero_from", input_type=Int(optional=True), prefix="--files0-from", doc=InputDocumentation(doc="read input from the files specified by\nfor more use temp files")), ToolInput(tag="in_general_numeric_sort", input_type=Boolean(optional=True), prefix="--general-numeric-sort", doc=InputDocumentation(doc="compare according to general numerical value")), ToolInput(tag="in_human_numeric_sort", input_type=Boolean(optional=True), prefix="--human-numeric-sort", doc=InputDocumentation(doc="compare human readable numbers (e.g., 2K 1G)\nIf F is - then read names from standard input")), ToolInput(tag="in_ignore_non_printing", input_type=Boolean(optional=True), prefix="--ignore-nonprinting", doc=InputDocumentation(doc="consider only printable characters")), ToolInput(tag="in_key", input_type=String(optional=True), prefix="--key", doc=InputDocumentation(doc="sort via a key; KEYDEF gives location and type")), ToolInput(tag="in_merge", input_type=Boolean(optional=True), prefix="--merge", doc=InputDocumentation(doc="merge already sorted files; do not sort")), ToolInput(tag="in_month_sort", input_type=Boolean(optional=True), prefix="--month-sort", doc=InputDocumentation(doc="compare (unknown) < 'JAN' < ... < 'DEC'\nmultiple options specify multiple directories")), ToolInput(tag="in_numeric_sort", input_type=Boolean(optional=True), prefix="--numeric-sort", doc=InputDocumentation(doc="compare according to string numerical value\nNUL-terminated names in file F;\nnumeric -n, random -R, version -V")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="write result to FILE instead of standard output")), ToolInput(tag="in_parallel", input_type=Int(optional=True), prefix="--parallel", doc=InputDocumentation(doc="change the number of sorts run concurrently to N")), ToolInput(tag="in_random_source", input_type=File(optional=True), prefix="--random-source", doc=InputDocumentation(doc="get random bytes from FILE")), ToolInput(tag="in_random_sort", input_type=Boolean(optional=True), prefix="--random-sort", doc=InputDocumentation(doc="sort by random hash of keys")), ToolInput(tag="in_reverse", input_type=Boolean(optional=True), prefix="--reverse", doc=InputDocumentation(doc="reverse the result of comparisons")), ToolInput(tag="in_buffer_size", input_type=Int(optional=True), prefix="--buffer-size", doc=InputDocumentation(doc="use SIZE for main memory buffer")), ToolInput(tag="in_sort_according_word", input_type=String(optional=True), prefix="--sort", doc=InputDocumentation(doc="sort according to WORD:")), ToolInput(tag="in_stable", input_type=Boolean(optional=True), prefix="--stable", doc=InputDocumentation(doc="stabilize sort by disabling last-resort comparison")), ToolInput(tag="in_field_separator", input_type=String(optional=True), prefix="--field-separator", doc=InputDocumentation(doc="use SEP instead of non-blank to blank transition")), ToolInput(tag="in_temporary_directory", input_type=Directory(optional=True), prefix="--temporary-directory", doc=InputDocumentation(doc="use DIR for temporaries, not $TMPDIR or /tmp;")), ToolInput(tag="in_unique", input_type=Boolean(optional=True), prefix="--unique", doc=InputDocumentation(doc="with -c, check for strict ordering;")), ToolInput(tag="in_version_sort", input_type=Boolean(optional=True), prefix="--version-sort", doc=InputDocumentation(doc="natural sort of (version) numbers within text")), ToolInput(tag="in_zero_terminated", input_type=Boolean(optional=True), prefix="--zero-terminated", doc=InputDocumentation(doc="line delimiter is NUL, not newline")), ToolInput(tag="in_var_27", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="write result to FILE instead of standard output"))], container="quay.io/biocontainers/entrez-direct:13.9--pl526h375a9b1_1", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Exclude_Uid_Lists_V0_1_0().translate("wdl")

